import { REFER } from "@/components/popover-select/api";
import { EXIST } from "@/api/business/purchase/catalogue";
import {  ITEM } from "@/api/business/purchase/apply";

export default function useMethods() {
  const fetchItem = async ({ _this, prop }) => {
    try {
      // try
      _this.loading = true;
      const { code, data } = await ITEM(prop);
      if (code === 200) {
        return data;
      }
    } catch (err) {
      // catch
      console.error(err);
    } finally {
      // finally
      _this.loading = false;
    }
  };
  const fetchRefer = async ({ _this, prop, type, source }) => {
    const { rateCode } = prop;
    if (type === "MATERIAL_PARAM") {
      try {
        // try
        _this.loading = true;
        // task 1
        const { code, rows } = await REFER({
          search: rateCode,
          type: "TAX_RATE_PARAM",
        });
        if (code === 200) {
          const [{ ntaxrate }] = rows;
          source.tax = ntaxrate === "0E-8" ? "0.00000000" : ntaxrate;
        }
        // task 2
        const { materialCode } = source;
        const { puOrg, customer, supplier } = _this.params;
        const {
          code: code2,
          data: { recentlyPrice, isApprovalFirst, isPriceAdjustment },
        } = await EXIST({
          puOrg,
          customer,
          supplier,
          materialCode,
        });
        if (code2 === 200) {
          source.recentlyPrice = recentlyPrice;
          source.isApprovalFirst = isApprovalFirst;
          source.isPriceAdjustment = isPriceAdjustment;
        }
      } catch (err) {
        // catch
        console.error(err);
      } finally {
        // finally
        _this.loading = false;
      }
    }
  };

  return {
    fetchItem,
    fetchRefer,
  };
}
